AppDomain.UnhandledException イベント

定義

例外がキャッチされない場合に発生します。Occurs when an exception is not caught.

public:
 virtual event UnhandledExceptionEventHandler ^ UnhandledException;
[add: System.Security.SecurityCritical]
[remove: System.Security.SecurityCritical]
public event UnhandledExceptionEventHandler UnhandledException;
member this.UnhandledException : UnhandledExceptionEventHandler 
Public Custom Event UnhandledException As UnhandledExceptionEventHandler 

実装

属性

UnhandledExceptionイベントの例を次に示します。The following example demonstrates the UnhandledException event. 既定のアプリケーションドメインでハンドルされない例外がスローされるたびに呼び出されるイベントハンドラー (MyHandler) を定義します。It defines an event handler, MyHandler, that is invoked whenever an unhandled exception is thrown in the default application domain. その後、2つの例外がスローされます。It then throws two exceptions. 最初のはtry/catchブロックによって処理されます。The first is handled by a try/catch block. 2番目のは処理されないので、アプリケーションが終了する前に MyHandle ルーチンを呼び出します。The second is unhandled and invokes the MyHandle routine before the application terminates.

// The example should be compiled with the /clr:pure compiler option.
using namespace System;
using namespace System::Security::Permissions;

public ref class Example
{


private:
   static void MyHandler(Object^ sender, UnhandledExceptionEventArgs^ args)
   {
      Exception^ e = dynamic_cast<Exception^>(args->ExceptionObject);
      Console::WriteLine( "MyHandler caught : {0}", e->Message );
      Console::WriteLine("Runtime terminating: {0}", args->IsTerminating);
   }
   
public: 
   [SecurityPermissionAttribute( SecurityAction::Demand, ControlAppDomain = true )]
   static void Main()
   {
      AppDomain^ currentDomain = AppDomain::CurrentDomain;
      currentDomain->UnhandledException += gcnew UnhandledExceptionEventHandler(Example::MyHandler);
      try
      {
         throw gcnew Exception("1");
      }
      catch (Exception^ e) 
      {
         Console::WriteLine( "Catch clause caught : {0}\n", e->Message );
      }

      throw gcnew Exception("2");
   }
};

void main()
{
   Example::Main();
}   
// The example displays the following output:
//       Catch clause caught : 1
//       
//       MyHandler caught : 2
//       Runtime terminating: True
//       
//       Unhandled Exception: System.Exception: 2
//          at Example.Main()
//          at mainCRTStartup(String[] arguments)
using System;
using System.Security.Permissions;

public class Example 
{
   [SecurityPermission(SecurityAction.Demand, Flags=SecurityPermissionFlag.ControlAppDomain)]
   public static void Main()
   {
      AppDomain currentDomain = AppDomain.CurrentDomain;
      currentDomain.UnhandledException += new UnhandledExceptionEventHandler(MyHandler);
      
      try {
         throw new Exception("1");
      } catch (Exception e) {
         Console.WriteLine("Catch clause caught : {0} \n", e.Message);
      }

      throw new Exception("2");
   }
   
   static void MyHandler(object sender, UnhandledExceptionEventArgs args) 
   {
      Exception e = (Exception) args.ExceptionObject;
      Console.WriteLine("MyHandler caught : " + e.Message);
      Console.WriteLine("Runtime terminating: {0}", args.IsTerminating);
   }
}
// The example displays the following output:
//       Catch clause caught : 1
//       
//       MyHandler caught : 2
//       Runtime terminating: True
//       
//       Unhandled Exception: System.Exception: 2
//          at Example.Main()  
Module Example
   Sub Main()
      Dim currentDomain As AppDomain = AppDomain.CurrentDomain
      AddHandler currentDomain.UnhandledException, AddressOf MyHandler
      
      Try
         Throw New Exception("1")
      Catch e As Exception
         Console.WriteLine("Catch clause caught : " + e.Message)
         Console.WriteLine()
      End Try
      
      Throw New Exception("2")
   End Sub
   
   Sub MyHandler(sender As Object, args As UnhandledExceptionEventArgs)
      Dim e As Exception = DirectCast(args.ExceptionObject, Exception)
      Console.WriteLine("MyHandler caught : " + e.Message)
      Console.WriteLine("Runtime terminating: {0}", args.IsTerminating)
   End Sub
End Module
' The example displays the following output:
'       Catch clause caught : 1
'       
'       MyHandler caught : 2
'       Runtime terminating: True
'       
'       Unhandled Exception: System.Exception: 2
'          at Example.Main()

注釈

このイベントは、キャッチされていない例外の通知を提供します。This event provides notification of uncaught exceptions. これにより、アプリケーションは例外に関する情報をログに記録してから、システムの既定のハンドラーがユーザーに例外を報告し、アプリケーションを終了します。It allows the application to log information about the exception before the system default handler reports the exception to the user and terminates the application. アプリケーションの状態に関する十分な情報が利用可能な場合は、後で回復するためにプログラムデータを保存するなど、他の操作が実行される可能性があります。If sufficient information about the state of the application is available, other actions may be undertaken - such as saving program data for later recovery. 例外が処理されない場合、プログラムデータが破損する可能性があるため、注意が必要です。Caution is advised, because program data can become corrupted when exceptions are not handled.

注意

.NET Framework バージョン1.0 および1.1 では、以降ではなく、このイベントが発生する前に、アプリケーションの終了オプションとデバッグオプションがユーザーに報告されます。In the .NET Framework versions 1.0 and 1.1, application termination and debugging options are reported to the user before this event is raised, rather than after.

このイベントは、任意のアプリケーションドメインで処理できます。This event can be handled in any application domain. ただし、イベントは、例外が発生したアプリケーションドメインで必ずしも発生するとは限りません。However, the event is not necessarily raised in the application domain where the exception occurred. 例外がハンドルされないのは、該当する例外ハンドラーを検出せずに、スレッドのスタック全体がアンワインドされている場合のみです。そのため、イベントが発生する最初の場所は、スレッドが発生したアプリケーションドメインにあります。An exception is unhandled only if the entire stack for the thread has been unwound without finding an applicable exception handler, so the first place the event can be raised is in the application domain where the thread originated.

注意

.NET Framework バージョン1.0 および1.1 では、このイベントは、アプリケーションの起動時にシステムによって作成された既定のアプリケーションドメインに対してのみ発生します。In the .NET Framework versions 1.0 and 1.1, this event occurs only for the default application domain that is created by the system when an application is started. アプリケーションで追加のアプリケーションドメインを作成する場合、これらのアプリケーションドメインにこのイベントのデリゲートを指定しても効果はありません。If an application creates additional application domains, specifying a delegate for this event in those applications domains has no effect.

UnhandledException イベントが既定のアプリケーションドメインで処理される場合、スレッドがどのアプリケーションドメインで開始されたかにかかわらず、任意のスレッドでハンドルされない例外が発生すると、そのイベントが発生します。If the UnhandledException event is handled in the default application domain, it is raised there for any unhandled exception in any thread, no matter what application domain the thread started in. UnhandledExceptionのイベントハンドラーを持つアプリケーションドメインでスレッドが開始された場合、そのアプリケーションドメインでイベントが発生します。If the thread started in an application domain that has an event handler for UnhandledException, the event is raised in that application domain. そのアプリケーションドメインが既定のアプリケーションドメインではなく、既定のアプリケーションドメインにもイベントハンドラーがある場合は、両方のアプリケーションドメインでイベントが発生します。If that application domain is not the default application domain, and there is also an event handler in the default application domain, the event is raised in both application domains.

たとえば、アプリケーションドメイン "AD1" でスレッドが開始され、アプリケーションドメイン "AD2" でメソッドが呼び出され、そこからアプリケーションドメイン "AD3" 内のメソッドが呼び出され、そこで例外がスローされたとします。For example, suppose a thread starts in application domain "AD1", calls a method in application domain "AD2", and from there calls a method in application domain "AD3", where it throws an exception. UnhandledException イベントが発生する最初のアプリケーションドメインは "AD1" です。The first application domain in which the UnhandledException event can be raised is "AD1". そのアプリケーションドメインが既定のアプリケーションドメインでない場合は、既定のアプリケーションドメインでイベントを発生させることもできます。If that application domain is not the default application domain, the event can also be raised in the default application domain.

注意

共通言語ランタイムは、UnhandledException イベントのイベントハンドラーの実行中に、スレッドの中止を中断します。The common language runtime suspends thread aborts while event handlers for the UnhandledException event are executing.

イベントハンドラーが適切なフラグを持つ ReliabilityContractAttribute 属性を持っている場合、イベントハンドラーは制約された実行領域として扱われます。If the event handler has a ReliabilityContractAttribute attribute with the appropriate flags, the event handler is treated as a constrained execution region.

.NET Framework 4.NET Framework 4以降では、イベントハンドラーがセキュリティクリティカルで、HandleProcessCorruptedStateExceptionsAttribute 属性を持っている場合を除き、プロセスの状態が破損している例外 (スタックオーバーフローやアクセス違反など) に対して、このイベントは発生しません。Starting with the .NET Framework 4.NET Framework 4, this event is not raised for exceptions that corrupt the state of the process, such as stack overflows or access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.

.NET Framework バージョン1.0 および1.1 では、メインアプリケーションスレッド以外のスレッドで発生するハンドルされない例外がランタイムによってキャッチされるため、アプリケーションは終了しません。In the .NET Framework versions 1.0 and 1.1, an unhandled exception that occurs in a thread other than the main application thread is caught by the runtime and therefore does not cause the application to terminate. したがって、アプリケーションを終了せずに UnhandledException イベントを発生させることができます。Thus, it is possible for the UnhandledException event to be raised without the application terminating. .NET Framework バージョン2.0 以降では、子スレッドで未処理の例外に対するこの関する安全策が削除されました。このようなサイレントエラーの累積的な影響には、パフォーマンスの低下、データの破損、およびハングアップが含まれていました。これらはすべて、デバック.Starting with the .NET Framework version 2.0, this backstop for unhandled exceptions in child threads was removed, because the cumulative effect of such silent failures included performance degradation, corrupted data, and lockups, all of which were difficult to debug. ランタイムが終了しないケースの一覧など、詳細については、「マネージスレッドの例外」を参照してください。For more information, including a list of cases in which the runtime does not terminate, see Exceptions in Managed Threads.

このイベントのイベントハンドラーを登録するには、必要なアクセス許可が必要です。または、SecurityException がスローされます。To register an event handler for this event, you must have the required permissions, or a SecurityException is thrown.

イベントの処理の詳細については、「処理とイベントの発生」を参照してください。For more information about handling events, see Handling and Raising Events.

未処理の例外に関するその他のイベントOther Events for Unhandled Exceptions

特定のアプリケーションモデルでは、メインアプリケーションスレッドでハンドルされない例外が発生した場合に、UnhandledException イベントが他のイベントによって割り込まれることがあります。For certain application models, the UnhandledException event can be preempted by other events if the unhandled exception occurs in the main application thread.

Windows フォームを使用するアプリケーションでは、メインアプリケーションスレッドでハンドルされない例外が発生すると、Application.ThreadException イベントが発生します。In applications that use Windows Forms, unhandled exceptions in the main application thread cause the Application.ThreadException event to be raised. このイベントが処理される場合、既定の動作では、ハンドルされない例外によってアプリケーションが終了することはありませんが、アプリケーションは不明な状態のままになります。If this event is handled, the default behavior is that the unhandled exception does not terminate the application, although the application is left in an unknown state. この場合、UnhandledException イベントは発生しません。In that case, the UnhandledException event is not raised. この動作は、アプリケーション構成ファイルを使用するか、Application.SetUnhandledExceptionMode メソッドを使用して、ThreadException イベントハンドラーがフックされる前に UnhandledExceptionMode.ThrowException にモードを変更することによって変更できます。This behavior can be changed by using the application configuration file, or by using the Application.SetUnhandledExceptionMode method to change the mode to UnhandledExceptionMode.ThrowException before the ThreadException event handler is hooked up. これは、メインアプリケーションスレッドにのみ適用されます。This applies only to the main application thread. UnhandledException イベントは、他のスレッドでスローされた未処理の例外に対して発生します。The UnhandledException event is raised for unhandled exceptions thrown in other threads.

Microsoft Visual Studio 2005 以降、Visual Basic アプリケーションフレームワークは、メインアプリケーションスレッドでハンドルされない例外に対して別のイベントを提供します。Starting with Microsoft Visual Studio 2005, the Visual Basic application framework provides another event for unhandled exceptions in the main application thread. WindowsFormsApplicationBase.UnhandledException イベントを参照してください。See the WindowsFormsApplicationBase.UnhandledException event. このイベントには、AppDomain.UnhandledExceptionによって使用されるイベント引数オブジェクトと同じ名前のイベント引数オブジェクトがありますが、プロパティは異なります。This event has an event arguments object with the same name as the event arguments object used by AppDomain.UnhandledException, but with different properties. 特に、このイベント引数オブジェクトには ExitApplication プロパティがあります。このプロパティを使用すると、アプリケーションの実行を継続でき、未処理の例外は無視され、アプリケーションは不明な状態のままになります。In particular, this event arguments object has an ExitApplication property that allows the application to continue running, ignoring the unhandled exception (and leaving the application in an unknown state). この場合、AppDomain.UnhandledException イベントは発生しません。In that case, the AppDomain.UnhandledException event is not raised.

セキュリティ

SecurityCriticalAttribute
直前の呼び出し元に完全信頼が必要です。requires full trust for the immediate caller. このメンバーは、部分的に信頼されているコードまたは透過的なコードでは使用できません。This member cannot be used by partially trusted or transparent code.

適用対象